Subject: [PATCH] ipv6: fix raw socket checksum for udplite

From: Maciej Żenczykowski <[email-masked]>
Date: Tue, 26 Mar 2013 15:31:35 -0700

From: Maciej Żenczykowski <[email-masked]>

Commit d3a1be9cba86 from Brian Haley in Nov 2006
"[IPv6]: Only modify checksum for UDP" forgot about
UDPLITE.

(Not clear if this fix is sufficient for udp over raw6 socket
checksumming in kernel to be useful, but it's obviously wrong
as is.)

RFC 3828 section 3.1, 3rd paragraph:

If the computed checksum is 0, it is transmitted as all ones
(the equivalent in one's complement arithmetic).

Signed-off-by: Maciej Żenczykowski <[email-masked]>
Cc: Eric Dumazet <[email-masked]>
Cc: Mike Dalton <[email-masked]>
Cc: Brian Haley <[email-masked]>
---
 net/ipv6/raw.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/net/ipv6/raw.c b/net/ipv6/raw.c
index eedff8ccded5..745e925eff17 100644
--- a/net/ipv6/raw.c
+++ b/net/ipv6/raw.c
@@ -590,7 +590,8 @@ static int rawv6_push_pending_frames(struct sock *sk, struct flowi6 *fl6,
 	csum = csum_ipv6_magic(&fl6->saddr, &fl6->daddr,
 			       total_len, fl6->flowi6_proto, tmp_csum);
 
-	if (csum == 0 && fl6->flowi6_proto == IPPROTO_UDP)
+	if (csum == 0 && (fl6->flowi6_proto == IPPROTO_UDP
+	    || fl6->flowi6_proto == IPPROTO_UDPLITE))
 		csum = CSUM_MANGLED_0;
 
 	if (skb_store_bits(skb, offset, &csum, 2))
-- 
1.8.1.3